#!/bin/bash

# Author: Christophe Casalegno / Brain 0verride
# Website: https://www.christophe-casalegno.com
# Twitter: https://twitter.com/Brain0verride
# Email: brain@christophe-casalegno.com
# Note: Only tested on Debian Stretch (9)


# Vars

replacer='sed' 				# command used for replacement 
replacer_options='-i' 			# options for the replacer

mysql_conf='/etc/mysql/my.cnf'

server=$1
ippriv=$2
sshport="65022"
rootdir="/etc/systemd/network"
privatelinkfile="666-private-interface.link"
privatenetworkfile="666-vrack.network"

function checkip()
{
if [[ "$1" =~ (([01]{,1}[0-9]{1,2}|2[0-4][0-9]|25[0-5])\.([01]{,1}[0-9]{1,2}|2[0-4][0-9]|25[0-5])\.([01]{,1}[0-9]{1,2}|2[0-4][0-9]|25[0-5])\.([01]{,1}[0-9]{1,2}|2[0-4][0-9]|25[0-5]))$ ]];
  then
        echo -e "${GREEN} [ OK ]" "${NC} IP address $1 is ok, install in progress..."
  else

        echo -e "${RED} [ ERROR ]" "${NC}  $1 is not an IP address"
        exit 0
fi
}

function writefile()

{
option=$1
file2write="$2"
contentfile="$3"

if [ "$option" = "add" ]
then

cat >>$file2write <<EOF
$contentfile
EOF

fi

if [ "$option" = "create" ]
then

cat >$file2write <<EOF
$contentfile
EOF

fi
}

function remoteexec()
{
	host_ip="$1"
	remoteport="$2"
	command2exec="$3"
	ssh -l root -p "$remoteport" "$host_ip" "$command2exec"
}

function scpcopy()
{
	host_ip="$1"
	scpuser="$2"
	scp_port="$3"
	file2cp="$4"
	dir2cp="$5"
	scp -oPort="$scp_port" "$file2cp" "$scpuser"@"$host_ip":"$dir2cp"
}

checkip "$2"

macaddress=$(remoteexec "$server" "$sshport" "cat /sys/class/net/eno2/address")

content_privatenetworkfile="
[Match]
MACAddress=$macaddress

[Network]
Description=network interface on vRack / private network
DHCP=no
Address=$ippriv/24
"
content_privatelinkfile="
[Match]
MACAddress=$macaddress

[Link]
Description=network interface on private network / vRack
MACAddressPolicy=persistent
NamePolicy=kernel database onboard slot path mac
#Name=eth1	# name under which this interface is known under OVH rescue system
#Name=eno2	# name under which this interface is probably known by systemd
"

writefile "create" "$privatelinkfile" "$content_privatelinkfile"
writefile "create" "$privatenetworkfile" "$content_privatenetworkfile"
scpcopy "$server" "root" "$sshport" "$privatelinkfile" "$rootdir"
scpcopy "$server" "root" "$sshport" "$privatenetworkfile" "$rootdir"
